
/* dummy efi.h - bits and pieces taken from the real thing */

#ifndef _EFI_H_INCLUDED_
#define _EFI_H_INCLUDED_

/*****************************************************************************/

typedef void            VOID;
typedef signed char     INT8;
typedef unsigned char   UINT8;
typedef short           INT16;
typedef unsigned short  UINT16;
typedef int             INT32;
typedef unsigned int    UINT32;
typedef long long       INT64;
typedef unsigned long long UINT64;

typedef UINT8           CHAR8;
typedef UINT8           BOOLEAN;
typedef UINT16          CHAR16;
typedef INT32           INTN;
typedef UINT32          UINTN;

typedef UINT64          EFI_STATUS;
typedef VOID*           EFI_HANDLE;

#ifndef IN
    #define IN
    #define OUT
    #define OPTIONAL
#endif

#define EFI_GLOBAL_VARIABLE \
    { 0x8BE4DF61, 0x93CA, 0x11D2, \
    {0xAA, 0x0D, 0x00, 0xE0, 0x98, 0x03, 0x2B, 0x8C}}

#define EFI_SUCCESS             0
#define EFI_INVALID_PARAMETER   0x8000000000000002
#define EFI_UNSUPPORTED         0x8000000000000003
#define EFI_BUFFER_TOO_SMALL    0x8000000000000005
#define EFI_OUT_OF_RESOURCES    0x8000000000000009
#define EFI_NOT_FOUND           0x800000000000000e
#define EFI_SECURITY_VIOLATION  0x800000000000001a

#define EFI_VARIABLE_NON_VOLATILE           0x00000001
#define EFI_VARIABLE_BOOTSERVICE_ACCESS     0x00000002
#define EFI_VARIABLE_RUNTIME_ACCESS         0x00000004
#define EFI_VARIABLE_TIME_BASED_AUTHENTICATED_WRITE_ACCESS    0x00000020
#define EFI_VARIABLE_APPEND_WRITE           0x00000040


typedef struct {          
    UINT32  Data1;
    UINT16  Data2;
    UINT16  Data3;
    UINT8   Data4[8]; 
} EFI_GUID;

typedef struct {          
    UINT16      Year;       // 1998 - 20XX
    UINT8       Month;      // 1 - 12
    UINT8       Day;        // 1 - 31
    UINT8       Hour;       // 0 - 23
    UINT8       Minute;     // 0 - 59
    UINT8       Second;     // 0 - 59
    UINT8       Pad1;
    UINT32      Nanosecond; // 0 - 999,999,999
    INT16       TimeZone;   // -1440 to 1440 or 2047
    UINT8       Daylight;
    UINT8       Pad2;
} EFI_TIME;

/*****************************************************************************/
#endif
